
#include "stdafx.h"
#include "ConfigManager.h"
#include "rsrc/resource.h"
#include "RSearch.h"
using namespace ki;
using namespace editwing;



void BootNewProcess( const TCHAR* cmd ); // in GpMain.cpp

//-------------------------------------------------------------------------
// ݒ荀ڊǗB
// SetDocTypeŐ؂ւƁA^Cvˑ̍ڂ
// ւFXB
//-------------------------------------------------------------------------

ConfigManager::ConfigManager()
{
	// ftHg̃CAEgݒ͉ɓǂł
	DocType d;
	d.name.Load( IDS_DEFAULT );
	d.layfile   = TEXT("default.lay");
	LoadLayout( &d );
	dtList_.Add( d );
	curDt_ = dtList_.begin();

	// iniǂݍ
	LoadIni();
}

void ConfigManager::SetDocTypeByName( const ki::String& nam )
{
	curDt_             = dtList_.begin();
	DtList::iterator b = dtList_.begin();
	DtList::iterator e = dtList_.end();
	for( ; b!=e; ++b )
		if( b->name == nam )
		{
			curDt_ = b;
			break;
		}
	LoadLayout( &*curDt_ );
}

int ConfigManager::SetDocType( const Path& fname )
{
	const unicode* uname = fname.ConvToWChar();

	int ct = 1;
	DtList::iterator i=dtList_.begin(), e=dtList_.end();
	if( fname.len() > 0 )
	{
		for( ++i; i!=e; ++i, ++ct )
			if( i->pattern.len() > 0 )
			{
				const unicode* upat = i->pattern.ConvToWChar();
				bool b = MatchDocType( uname, upat );
				i->pattern.FreeWCMem( upat );
				if( b ) break;
			}
		if( i == e )
			ct=0, i=dtList_.begin(); // K؂Ȃ̂Ȃ[W]B
	}
	else
	{
		ct = 0;
	}

	SetDocTypeByName( i->name );

	fname.FreeWCMem( uname );
	return ct;
}

bool ConfigManager::MatchDocType
	( const unicode* fname, const unicode* pat )
{
	// pattern  fname Ƃ̃}b`ƂĔc
	return reg_match( pat, fname, false );
}



//-------------------------------------------------------------------------
// ݒ_CAO֘A
//-------------------------------------------------------------------------

struct ConfigDlg : public ki::DlgImpl
{
private:
	typedef ConfigManager::DtList::iterator DTI;
	ulong curSel_;
	void SaveDt()
	{
		DTI p=myDtl_.begin(), e=myDtl_.end();
		for( ulong ct=0; p!=e && ct!=curSel_; ++ct,++p );
		if( p==e ) return;

		TCHAR buf[256];
		SendMsgToItem(IDC_DT_PAT, WM_GETTEXT,
			countof(buf),reinterpret_cast<LPARAM>(buf));
		p->pattern = buf;

		SendMsgToItem(IDC_PAT_KWD, CB_GETLBTEXT,
			SendMsgToItem(IDC_PAT_KWD, CB_GETCURSEL),
			reinterpret_cast<LPARAM>(buf) );
		p->kwdfile = buf;

		SendMsgToItem(IDC_PAT_LAY, CB_GETLBTEXT,
			SendMsgToItem(IDC_PAT_LAY, CB_GETCURSEL),
			reinterpret_cast<LPARAM>(buf) );
		p->layfile = buf;
	}
	void SelDt(ulong i)
	{
		DTI p=myDtl_.begin(), e=myDtl_.end();
		for( ulong ct=0; p!=e && ct!=i; ++ct,++p );
		if( p==e ) return;

		curSel_ = i;
		SendMsgToItem(IDC_DT_PAT, WM_SETTEXT, p->pattern.c_str());
		if( p->kwdfile.len()==0 )
			SendMsgToItem(IDC_PAT_KWD, CB_SETCURSEL);
		else
			SendMsgToItem(IDC_PAT_KWD,CB_SELECTSTRING,p->kwdfile.c_str());
		SendMsgToItem(IDC_PAT_LAY,CB_SELECTSTRING,p->layfile.c_str());
	}
	void on_deldoctype()
	{
		ulong ct;
		DTI p=myDtl_.begin(), e=myDtl_.end();
		for( ct=0; p!=e && ct!=curSel_; ++ct,++p );
		if( p==e ) return;

		String msg = TEXT("[");
		msg += p->name, msg += TEXT("]"), msg += String(IDS_OKTODEL);
		if( IDNO ==
			MsgBox( msg.c_str(), String(IDS_APPNAME).c_str(), MB_YESNO ) )
			return;

		myDtl_.Del(p);
		SendMsgToItem( IDC_DOCTYPELIST, LB_DELETESTRING, ct );
		SelDt(0);
	}
	void on_newdoctype()
	{
		struct NewDocTypeDlg : public DlgImpl
		{
			NewDocTypeDlg(HWND wnd)
				: DlgImpl(IDD_ADDDOCTYPE) { GoModal(wnd); }
			virtual bool on_ok()
			{
				TCHAR buf[MAX_PATH];
				SendMsgToItem(IDC_NAME, WM_GETTEXT,
					countof(buf),reinterpret_cast<LPARAM>(buf));
				name = buf;
				SendMsgToItem(IDC_EXT, WM_GETTEXT,
					countof(buf),reinterpret_cast<LPARAM>(buf));
				ext=buf;
				return true;
			}
			String name;
			String ext;
		} dlg( hwnd() );
		if( IDOK == dlg.endcode() )
		{
			ConfigManager::DocType ndt;
			TCHAR buf[200];
			SendMsgToItem(IDC_PAT_KWD, CB_GETLBTEXT,
				SendMsgToItem(IDC_PAT_KWD, CB_GETCURSEL),
				reinterpret_cast<LPARAM>(buf) );
			ndt.kwdfile = buf;
			SendMsgToItem(IDC_PAT_LAY, CB_GETLBTEXT,
				SendMsgToItem(IDC_PAT_LAY, CB_GETCURSEL),
				reinterpret_cast<LPARAM>(buf) );
			ndt.layfile = buf;
			ndt.name = dlg.name;
			ndt.pattern = TEXT(".*\\.")+dlg.ext+TEXT("$");
			myDtl_.Add(ndt);
			SendMsgToItem( IDC_DOCTYPELIST, LB_ADDSTRING,
				ndt.name.c_str() );
		}
	}

public:
	ConfigDlg( ConfigManager& cfg, HWND wnd )
		: cfg_( cfg )
		, DlgImpl( IDD_CONFIG )
		, curSel_( 0xffffffff )
	{
		for( DTI i=++cfg_.dtList_.begin(); i!=cfg_.dtList_.end(); ++i )
			myDtl_.Add( *i );
		GoModal( wnd );
	}

private:
	void on_init()
	{
		SendMsgToItem(IDC_LATEST_NUM, WM_SETTEXT,
			String().SetInt(cfg_.mlus_).c_str() );
		if( cfg_.undoLimit() == -1 )
		{
			SendMsgToItem(IDC_UNDOLIM1, BM_SETCHECK, BST_CHECKED);
			SendMsgToItem(IDC_UNDO_CT, WM_SETTEXT, TEXT("20") );
		}
		else
		{
			SendMsgToItem(IDC_UNDOLIM2, BM_SETCHECK, BST_CHECKED);
			SendMsgToItem(IDC_UNDO_CT, WM_SETTEXT,
				String().SetInt(cfg_.undoLimit()).c_str() );
		}
		SendMsgToItem(IDC_TXTFILT, WM_SETTEXT,
			cfg_.txtFileFilter().c_str() );
		SendMsgToItem(IDC_EXTGREP, WM_SETTEXT,
			cfg_.grepExe().c_str() );
		if( cfg_.openSame() )
			SendMsgToItem(IDC_OPENSAME, BM_SETCHECK, BST_CHECKED);

		for( DTI i=myDtl_.begin(), e=myDtl_.end(); i!=e; ++i )
			SendMsgToItem( IDC_DOCTYPELIST, LB_ADDSTRING,
				i->name.c_str() );

		FindFile f;
		WIN32_FIND_DATA fd;
		f.Begin( (Path(Path::Exe)+=TEXT("type\\*.kwd")).c_str() );
		SendMsgToItem( IDC_PAT_KWD, CB_ADDSTRING, TEXT("") );
		while( f.Next(&fd) )
			SendMsgToItem( IDC_PAT_KWD, CB_ADDSTRING, fd.cFileName );
		f.Begin( (Path(Path::Exe)+=TEXT("type\\*.lay")).c_str() );
		while( f.Next(&fd) )
			SendMsgToItem( IDC_PAT_LAY, CB_ADDSTRING, fd.cFileName );

		SelDt(0);

		SetCenter( hwnd(), ::GetParent(hwnd()) );
	}

	bool on_command( UINT cmd, UINT id, HWND ctrl )
	{
		switch( cmd )
		{
		case LBN_SELCHANGE:
			SaveDt();
			SelDt( SendMsgToItem( IDC_DOCTYPELIST, LB_GETCURSEL ) );
			break;
		default:
			TCHAR buf[256];
			switch( id )
			{
			case IDC_EDITKWD:
				SendMsgToItem(IDC_PAT_KWD, CB_GETLBTEXT,
					SendMsgToItem(IDC_PAT_KWD, CB_GETCURSEL),
					reinterpret_cast<LPARAM>(buf) );
				if( buf[0] != TEXT('\0') )
					BootNewProcess( (TEXT("\"")+Path(Path::Exe)+
						TEXT("type\\")+buf+TEXT("\"") ).c_str());
				break;
			case IDC_EDITLAY:
				SendMsgToItem(IDC_PAT_LAY, CB_GETLBTEXT,
					SendMsgToItem(IDC_PAT_LAY, CB_GETCURSEL),
					reinterpret_cast<LPARAM>(buf) );
				BootNewProcess( (TEXT("\"")+Path(Path::Exe)+
					TEXT("type\\")+buf+TEXT("\"") ).c_str());
				break;
			case IDC_NEWDOCTYPE:
				on_newdoctype();
				break;
			case IDC_DELDOCTYPE:
				on_deldoctype();
				break;
			default:
				return false;
			}
			break;
		}
		return true;
	}

	bool on_ok()
	{
		TCHAR buf[100];
		SendMsgToItem(IDC_LATEST_NUM, WM_GETTEXT,
			countof(buf),reinterpret_cast<LPARAM>(buf));
		cfg_.mlus_ = String::GetInt(buf);
		cfg_.mlus_ = Min(Max(cfg_.mlus_, 0), 8);

		if( BST_CHECKED == SendMsgToItem(IDC_UNDOLIM1, BM_GETCHECK) )
		{
			cfg_.undoLimit_ = -1;
		}
		else
		{
			SendMsgToItem(IDC_UNDO_CT, WM_GETTEXT,
				countof(buf),reinterpret_cast<LPARAM>(buf));
			cfg_.undoLimit_ = String::GetInt(buf);
		}

		SendMsgToItem(IDC_TXTFILT, WM_GETTEXT,
			countof(buf),reinterpret_cast<LPARAM>(buf));
		cfg_.txtFilter_ = buf;

		SendMsgToItem(IDC_EXTGREP, WM_GETTEXT,
			countof(buf),reinterpret_cast<LPARAM>(buf));
		cfg_.grepExe_ = buf;

		cfg_.openSame_ =
			( BST_CHECKED == SendMsgToItem(IDC_OPENSAME, BM_GETCHECK) );

		SaveDt();

		cfg_.dtList_.DelAfter( ++cfg_.dtList_.begin() );
		for( DTI i=myDtl_.begin(), e=myDtl_.end(); i!=e; ++i )
			cfg_.dtList_.Add( *i );
		return true;
	}

private:
	ConfigManager& cfg_;
	ConfigManager::DtList myDtl_;
};

bool ConfigManager::DoDialog( const ki::Window& parent )
{
	LoadIni();
	{
		ConfigDlg dlg(*this, parent.hwnd());
		if( IDOK != dlg.endcode() )
			return false;
		curDt_ = dtList_.begin(); // Ƃ肠
	}
	SaveIni();
	return true;
}



//-------------------------------------------------------------------------
// *.lay t@C̓ǂݍݏ
//-------------------------------------------------------------------------

namespace {
	static ulong ToByte( unicode* str )
	{
		ulong c = str[0];
			 if( L'a' <= str[0] ) c -= (L'a' - 10);
		else if( L'A' <= str[0] ) c -= (L'A' - 10);
		else                      c -=  L'0';
		c = c*16 + str[1];
			 if( L'a' <= str[1] ) c -= (L'a' - 10);
		else if( L'A' <= str[1] ) c -= (L'A' - 10);
		else                      c -=  L'0';
		return c;
	}
	static ulong GetColor( unicode* str )
	{
		return ToByte(str) + (ToByte(str+2)<<8) + (ToByte(str+4)<<16);
	}
	static int GetInt( unicode* str )
	{
		int c = 0;
		int s = 1;
		if( *str == L'-' )
			s=-1, ++str;
		for( ; *str!=L'\0'; ++str )
			c = c * 10 + *str - L'0';
		return c*s;
	}
}

void ConfigManager::LoadLayout( DocType* dt )
{
  // PDȗlƂāc

	DtList::iterator ref = dtList_.begin();
	if( ref != dtList_.end() )
	{
		// default.lay[hĂ΂g
		dt->vc        = ref->vc;
		dt->wrapWidth = ref->wrapWidth;
		dt->wrapType  = ref->wrapType;
		dt->showLN    = ref->showLN;
	}
	else
	{
		// gݍ݂̃ftHgݒ[h
		dt->vc.SetFont( TEXT("FixedSys"), 14 );
		dt->vc.SetTabStep( 4 );
		dt->vc.color[TXT] = RGB(0,0,0);
		dt->vc.color[KWD] = RGB(0,90,230);
		dt->vc.color[CMT] = RGB(0,0,0);
		dt->vc.color[BG]  = RGB(255,255,255);
		dt->vc.color[CTL] = RGB(240,200,240);
		dt->vc.sc[scEOF]  = dt->vc.sc[scEOL]=true;
		dt->vc.sc[scHSP]  = dt->vc.sc[scZSP]=dt->vc.sc[scTAB]=false;
		dt->wrapWidth  = 80;
		dt->wrapType   = -1;
		dt->showLN     = false;
	}

  // QD*.layt@C̓ǂݍ

	TextFileR tf( UTF16LE );
	if( tf.Open( (Path(Path::Exe)+TEXT("type\\")+dt->layfile).c_str() ) )
	{
		String fontname;
		int    fontsize=0;
		int    x;

		unicode buf[1024], *ptr=buf+3;
		while( tf.state() != 0 ) // !EOF
		{
			ulong len = tf.ReadLine( buf, countof(buf)-1 );
			if( len<=3 || buf[2]!=L'=' )
				continue;
			buf[len] = L'\0';

			switch( (buf[0]<<16)|buf[1] )
			{
			case 0x00630074: // ct: COLOR-TEXT
				dt->vc.color[TXT] = GetColor(ptr);
				break;
			case 0x0063006B: // ck: COLOR-KEYWORD
				dt->vc.color[KWD] = GetColor(ptr);
				break;
			case 0x00630062: // cb: COLOR-BACKGROUND
				dt->vc.color[BG ] = GetColor(ptr);
				break;
			case 0x00630063: // cc: COLOR-COMMENT
				dt->vc.color[CMT] = GetColor(ptr);
				break;
			case 0x0063006E: // cn: COLOR-CONTROL
				dt->vc.color[CTL] = GetColor(ptr);
				break;
			case 0x00660074: // ft: FONT
				fontname = ptr;
				break;
			case 0x0073007A: // sz: SIZE
				fontsize = GetInt(ptr);
				break;
			case 0x00740062: // tb: TAB
				dt->vc.SetTabStep( GetInt(ptr) );
				break;
			case 0x00730063: // sc: SPECIAL-CHAR
				x = GetInt(ptr);
				dt->vc.sc[scZSP] = (0!=x%10); x/=10;
				dt->vc.sc[scHSP] = (0!=x%10); x/=10;
				dt->vc.sc[scTAB] = (0!=x%10); x/=10;
				dt->vc.sc[scEOL] = (0!=x%10); x/=10;
				dt->vc.sc[scEOF] = (0!=x%10);
				break;
			case 0x00770070: // wp: WRAP-TYPE
				dt->wrapType = GetInt(ptr);
				break;
			case 0x00770077: // ww: WRAP-WIDTH
				dt->wrapWidth = GetInt(ptr);
				break;
			case 0x006C006E: // ln: LINE-NO
				dt->showLN = (0!=GetInt(ptr));
				break;
			}
		}

		if( fontname.len()!=0 && fontsize!=0 )
			dt->vc.SetFont( fontname.c_str(), fontsize );
	}
}



//-------------------------------------------------------------------------
// *.ini t@C̓ǂݍ/ݏ
//-------------------------------------------------------------------------

void ConfigManager::LoadIni()
{
	{
		FileW fp;
		Path inipath(Path::Exe);
		inipath+=Path(Path::ExeName).body();
		inipath+=TEXT(".ini");
		if( !inipath.exist() && fp.Open(inipath.c_str()) )
		{
			static const char s_defaultIni[] =
"[DocType]\r\n"
"1=C/C++\r\n"
"2=HTML\r\n"
"3=INI\r\n"
"4=UnicodeText\r\n"
"\r\n"
"[C/C++]\r\n"
"Pattern=.*(\\.(c|cpp|cxx|cc|h|hpp)|include\\\\\\.+)$\r\n"
"Keyword=c.kwd\r\n"
"Layout=c.lay\r\n"
"\r\n"
"[HTML]\r\n"
"Pattern=.*(\\.html|\\.htm|\\.asp|\\.php|\\.php3|temporary internet files\\\\.+)$\r\n"
"Keyword=html.kwd\r\n"
"Layout=html.lay\r\n"
"\r\n"
"[INI]\r\n"
"Pattern=.*\\.ini$\r\n"
"Keyword=ini.kwd\r\n"
"\r\n"
"[UnicodeText]\r\n"
"Layout=unitext.lay\r\n";
			fp.Write( s_defaultIni, sizeof(s_defaultIni)-1 );
		}
	}

	// ʂ̐ݒ
	ini_.SetSectionAsUserName();
	undoLimit_ = ini_.GetInt( TEXT("UndoLimit"), -1 );
	txtFilter_ = ini_.GetStr( TEXT("TxtFilter"),
		TEXT("*.txt;*.htm;*.html;*.c;*.cpp;*.cc;*.cxx;*.h;*.hpp") );
	grepExe_   = ini_.GetStr( TEXT("GrepExe"), TEXT("") );
	openSame_  = ini_.GetBool( TEXT("OpenSame"), false );

	// TODO: MLU
	mlus_ = ini_.GetInt( TEXT("MLU"), 4 );
	mlus_ = Min(Max(mlus_, 0), 7);

	// ^CvXĝOԈȊÕNA
	dtList_.DelAfter( ++dtList_.begin() );

	String s, r;
	for( int i=1; true; ++i )
	{
		// ^Cvǂݍ
		ini_.SetSection( TEXT("DocType") );
		s.SetInt(i);
		r = ini_.GetStr( s.c_str(), String() );
		if( r.len() == 0 )
			break;

		// ̕^Cvۂɓǂݍ
		ini_.SetSection( r.c_str() );
		{
			DocType d;
			d.name      = r;
			d.layfile   = ini_.GetStr( TEXT("Layout"),TEXT("default.lay"));
			d.kwdfile   = ini_.GetStr( TEXT("Keyword"), String() );
			d.pattern   = ini_.GetStr( TEXT("Pattern"), String() );
			dtList_.Add( d );
		}
	}
}

void ConfigManager::SaveIni()
{
	// ʂ̐ݒ
	ini_.SetSectionAsUserName();
	ini_.PutInt( TEXT("UndoLimit"), undoLimit_ );
	ini_.PutStr( TEXT("TxtFilter"), txtFilter_.c_str() );
	ini_.PutStr( TEXT("GrepExe"), grepExe_.c_str() );
	ini_.PutBool( TEXT("OpenSame"), openSame_ );

	// TODO: MLU
	ini_.PutInt( TEXT("MLU"), mlus_ );

	// TODO: DocType
	for(DtList::iterator i=++dtList_.begin(); i!=dtList_.end(); ++i )
	{
		ini_.SetSection( i->name.c_str() );
		ini_.PutStr( TEXT("Pattern"), i->pattern.c_str() );
		ini_.PutStr( TEXT("Keyword"), i->kwdfile.c_str() );
		ini_.PutStr( TEXT("Layout"), i->layfile.c_str() );
	}

	ulong ct=1;
	ini_.SetSection( TEXT("DocType") );
	for(DtList::iterator i=++dtList_.begin(); i!=dtList_.end(); ++i,++ct)
		ini_.PutStr( String().SetInt(ct).c_str(), i->name.c_str() );
	ini_.PutStr( String().SetInt(ct).c_str(), TEXT("") );
}



//-------------------------------------------------------------------------
// [ŋߎgt@C]֌W
//-------------------------------------------------------------------------

namespace {
	static const TCHAR* const s_mlulock = TEXT("GreenPad_MLUMutex");
}

void ConfigManager::AddMLU( const Path& fname )
{
	Mutex mx(s_mlulock);

	// MLUXgXV
	{
		int i;
		for( i=0; i<countof(mlu_); ++i )
			if( mlu_[i] == fname )
			{
				mlu_[i] = mlu_[0];
				break;
			}
		if( i==countof(mlu_) )
			for( --i; i>0; --i )
				mlu_[i] = mlu_[i-1];
		mlu_[0] = fname;
	}

	// ini֕ۑ
	{
		ini_.SetSectionAsUserName();
		const String key = TEXT("MLU");
		for( int i=0; i<countof(mlu_); ++i )
			ini_.PutStr(
				(key+String().SetInt(i+1)).c_str(), mlu_[i].c_str() );
	}
}

void ConfigManager::SetUpMLUMenu( HMENU m, UINT id )
{
	Mutex mx(s_mlulock);

	// iniǂݍ
	{
		ini_.SetSectionAsUserName();
		const String key = TEXT("MLU");
		for( int i=0; i<countof(mlu_); ++i )
			mlu_[i] = ini_.GetStr(
				(key+String().SetInt(i+1)).c_str(), String() );
	}

	// Sڂ폜
	while( ::DeleteMenu( m, 0, MF_BYPOSITION ) );

	// j[\z
	MENUITEMINFO mi = { sizeof(MENUITEMINFO) };
	mi.fMask = MIIM_ID;
	mi.fMask |= app().isWin95() ? MIIM_TYPE : 0x00000140; // (MIIM_FTYPE|MIIM_STRING)
	mi.fType = MFT_STRING;
	for( int i=0; i<countof(mlu_); ++i )
	{
		if( i>=mlus_ || mlu_[i].len()==0 )
		{
			if( i==0 )
			{
				mi.fMask     |= MIIM_STATE;
				mi.wID        = id;
				mi.fState     = MFS_DISABLED;
				mi.dwTypeData = TEXT("no files");
				mi.cch        = 0;
				::InsertMenuItem( m, 0, MF_BYPOSITION, &mi );
			}
			break;
		}
		mi.wID        = id + i;
		mi.dwTypeData = const_cast<TCHAR*>(mlu_[i].c_str());
		mi.cch        = mlu_[i].len();
		::InsertMenuItem( m, i, MF_BYPOSITION, &mi );
	}
}

Path ConfigManager::GetMLU( int no ) const
{
	return (0<=no && no<mlus_ ? mlu_[no] : Path());
}




//-------------------------------------------------------------------------
// [^Cv]Tuj[̍쐬
//-------------------------------------------------------------------------

void ConfigManager::SetDocTypeMenu( HMENU m, UINT idstart )
{
	// Sڂ폜
	while( ::DeleteMenu( m, 0, MF_BYPOSITION ) );

	// ɒǉ
	MENUITEMINFO mi = { sizeof(MENUITEMINFO) };
	mi.fMask = MIIM_ID | MIIM_STATE;
	mi.fMask |= app().isWin95() ? MIIM_TYPE : 0x00000140; // (MIIM_FTYPE|MIIM_STRING)
	mi.fType = MFT_STRING | MFT_RADIOCHECK;

	DtList::iterator i=dtList_.begin(), e=dtList_.end();
	for( int ct=0; i!=e; ++i, ++ct )
	{
		mi.wID        = idstart + ct;
		mi.fState     = (i==curDt_ ? MFS_CHECKED : MFS_UNCHECKED);
		mi.dwTypeData = const_cast<TCHAR*>(i->name.c_str());
		mi.cch        = i->name.len();
		::InsertMenuItem( m, ct, MF_BYPOSITION, &mi );
	}
}

void ConfigManager::SetDocTypeByMenu( int pos, HMENU m )
{
	MENUITEMINFO mi = { sizeof(MENUITEMINFO) };
	mi.fMask  = MIIM_STATE;

	DtList::iterator i=dtList_.begin(), e=dtList_.end();
	for( int ct=0; i!=e; ++i, ++ct )
	{
		mi.fState     = (ct==pos ? MFS_CHECKED : MFS_UNCHECKED);
		::SetMenuItemInfo( m, ct, MF_BYPOSITION, &mi );
		if( ct == pos )
		{
			curDt_ = i;
			LoadLayout( &*curDt_ );
		}
	}
}

void ConfigManager::CheckMenu( HMENU m, int pos )
{
	MENUITEMINFO mi = { sizeof(MENUITEMINFO) };
	mi.fMask  = MIIM_STATE;

	DtList::iterator i=dtList_.begin(), e=dtList_.end();
	for( int ct=0; i!=e; ++i, ++ct )
	{
		mi.fState     = (ct==pos ? MFS_CHECKED : MFS_UNCHECKED);
		::SetMenuItemInfo( m, ct, MF_BYPOSITION, &mi );
	}
}

