#ifndef AFX_SEARCH_H__201E0D70_9C20_420A_8600_966D2BA23010__INCLUDED_
#define AFX_SEARCH_H__201E0D70_9C20_420A_8600_966D2BA23010__INCLUDED_
#include "editwing/editwing.h"
#include "kilib/memory.h"
#include "kilib/ktlaptr.h"
#include "kilib/string.h"



//=========================================================================
//@{ @pkg Gp.Search //@}
//@{
//	IuWFNg
//@}
//=========================================================================

class Searchable : public ki::Object
{
public:
	//@{
	//	s
	//	@param str Ώە
	//	@param len Ώە̒
	//	@param stt JnindexB0Ȃ擪
	//	@param mbg }b`ʂ̐擪index
	//	@param med }b`ʂ̏I[index̂P
	//	@return }b`ǂ
	//
	//	T[`IuWFNg̏ꍇAstt <= *beg ͈̔
	//	T[`IuWFNg̏ꍇA*beg <= stt ͈̔͂
	//@}
	virtual bool Search( const unicode* str, ulong len, ulong stt,
		ulong* mbg, ulong* med ) = 0;
};



//=========================================================================
//@{
//	Ǘl
//
//	O񌟍Ƃ̃IvV⌟oĂ̂
//	̃NX̒SBEu_CAO̕\
//	邩ȂB
//@}
//=========================================================================

class SearchManager : ki::DlgImpl
{
	typedef editwing::DPos DPos;

public:
	//@{ RXgN^BL //@}
	SearchManager( editwing::EwEdit& e );

	//@{ fXgN^BL //@}
	~SearchManager();

	//@{ _CAO\ //@}
	void ShowDlg();

	//@{ []R}h //@}
	void FindNext();

	//@{ [O]R}h //@}
	void FindPrev();

	//@{ \H //@}
	bool isReady() const
		{ return searcher_.isValid(); }

private:

	//@{ [u]R}h //@}
	void ReplaceImpl();

	//@{ [Su]R}h //@}
	void ReplaceAllImpl();

private:
	
	virtual void on_init();
	virtual void on_destroy();
	virtual bool on_command( UINT cmd, UINT id, HWND ctrl );
	void on_findnext();
	void on_findprev();
	void on_replacenext();
	void on_replaceall();
	void UpdateData();
	void ConstructSearcher( bool down=true );
	void FindNextImpl();
	void FindPrevImpl();
	bool FindNextFromImpl( DPos s, DPos* beg, DPos* end );
	bool FindPrevFromImpl( DPos s, DPos* beg, DPos* end );

private:
	editwing::EwEdit& edit_;
	ki::dptr<Searchable> searcher_;

	bool bIgnoreCase_; // 啶𓯈ꎋH
	bool bRegExp_;     // K\H
	bool bDownSearch_; // 
	bool bChanged_;    // Osearcher\zύXtrue

	ki::String findStr_;
	ki::String replStr_;

private:
	NOCOPY(SearchManager);
};



//=========================================================================

#endif // AFX_SEARCH_H__201E0D70_9C20_420A_8600_966D2BA23010__INCLUDED_
