#include "stdafx.h"
#include "registry.h"
using namespace ki;



//=========================================================================

void IniFile::SetFileName( const TCHAR* ini, bool exepath )
{
	iniName_ =
		(exepath  ? iniName_.BeSpecialPath(Path::Exe) : Path(TEXT("")));
	if( ini != NULL )
		iniName_ += ini;
	else
		iniName_ += (Path(Path::ExeName).body()+=TEXT(".ini"));
}

void IniFile::SetSectionAsUserName()
{
	TCHAR usr[256];
	DWORD siz = countof(usr);
	if( !::GetUserName( usr, &siz ) )
		::lstrcpy( usr, TEXT("Default") );
	SetSection( usr );
}

int IniFile::GetInt ( const TCHAR* key, int defval ) const
{
	return ::GetPrivateProfileInt(
		section_.c_str(), key, defval, iniName_.c_str() );
}

bool IniFile::GetBool( const TCHAR* key, bool defval ) const
{
	return (0!=::GetPrivateProfileInt(
		section_.c_str(), key, defval?1:0, iniName_.c_str() ));
}

String IniFile::GetStr ( const TCHAR* key, const String& defval ) const
{
	RawString str;
	ulong l=256, s;
	for(;;)
	{
		TCHAR* x = str.AllocMem(l);
		s = ::GetPrivateProfileString( section_.c_str(), key,
			defval.c_str(), x, l, iniName_.c_str() );
		if( s < l-1 )
			break;
		l <<= 1;
	}
	str.UnlockMem();
	return str;
}

bool IniFile::PutStr ( const TCHAR* key, const TCHAR* val )
{
	return (FALSE != ::WritePrivateProfileString(
		section_.c_str(), key, val, iniName_.c_str() ) );
}

bool IniFile::PutInt ( const TCHAR* key, int val )
{
	TCHAR buf[20];
	::wsprintf( buf, TEXT("%d"), val );
	return PutStr( key, buf );
}

bool IniFile::PutBool( const TCHAR* key, bool val )
{
	return PutStr( key, val ? TEXT("1") : TEXT("0") );
}
